;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : AT90S8535
;Clock frequency     : 4,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 152 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.DEVICE AT90S8535
	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0x30
	.EQU __sm_powerdown=0x20

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "testCSSI.vec"
	.INCLUDE "testCSSI.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xF8)
	LDI  R29,HIGH(0xF8)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0xF8
;       1 /*************************************************************
;       2 Project :  Test des fonctionnalits de la carte AT90S8535 SSI
;       3 Create :  8/03/2003
;       4 Version : 1
;       5 Rvision : 5     Date    : 03/03/2008
;       6 Author  : Philippe Mariano                
;       7 Company : LYCEE Pierre Emile MARTIN       
;       8 Comments: Test des BP, des DELs, des entres TOR, du Buzzer,
;       9 de l'entre analogique, du capteur de temprature DS1621,
;      10 de l'EEPROM externe, de l'HTR PCF8583, de la RS232, de la PWM
;      11 Chip type           : AT90S8535
;      12 Clock frequency     : 4,000000 MHz
;      13 Memory model        : Small
;      14 Internal SRAM size  : 512
;      15 External SRAM size  : 0
;      16 Data Stack size     : 152 !!!!!!!!!!!!!!!!!
;      17 ************************************************************/
;      18 
;      19 #include <90s8535.h> 
;      20 
;      21 // Librairies non gnres par Wizard (rajoutes manuellement)
;      22 //-----------------------------------------------------------------      
;      23 #include <ssi.h>      // contient les fonctions Lire_BP,Affiche_LCD etc..
;      24 #include <delay.h>    // contient la fonction delay_ms
;      25 #include <stdio.h>    // contient la fonction sprintf 
;      26 #include <stdlib.h>   // contient la fonction itoa
;      27 #include <math.h>
;      28 
;      29 // Accs aux caractres en CGRAM 
;      30 // --------------------------------
;      31 #define Caractere_FlecheH	0 
;      32 #define Caractere_FlecheB	1
;      33 
;      34 // @ I2C HTR
;      35 // --------------------------------
;      36 #define	adresse_HTR	0
;      37 
;      38 // Adresse CGRAM de l'afficheur LCD
;      39 // --------------------------------
;      40 #define Add_FlecheH_CGRAM 0x40 // @1 Caractre flche haut
;      41 #define Add_FlecheB_CGRAM 0x48 // @2 Caractre flche bas
;      42 
;      43 // I2C Bus functions
;      44 #asm
;      45    .equ __i2c_port=0x12
   .equ __i2c_port=0x12
;      46    .equ __sda_bit=3
   .equ __sda_bit=3
;      47    .equ __scl_bit=7
   .equ __scl_bit=7
;      48 #endasm

;      49 #include <i2c.h>
;      50 
;      51 // DS1621 Thermometer/Thermostat functions
;      52 #include <ds1621.h>
;      53 
;      54 // PCF8583 Real Time Clock functions
;      55 #include <pcf8583.h>
;      56 
;      57 // Alphanumeric LCD Module functions
;      58 #asm
;      59    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      60 #endasm

;      61 #include <lcd.h>
;      62 
;      63 // Read the AD conversion result
;      64 unsigned int read_adc(unsigned char adc_input)
;      65 {

	.CSEG
_read_adc:
;      66 ADMUX=adc_input;
	LD   R30,Y
	OUT  0x7,R30
;      67 // Start the AD conversion
;      68 ADCSR|=0x40;
	SBI  0x6,6
;      69 // Wait for the AD conversion to complete
;      70 while ((ADCSR & 0x10)==0);
_0x70:
	SBIS 0x6,4
	RJMP _0x70
;      71 ADCSR|=0x10;
	SBI  0x6,4
;      72 return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
;      73 }    
;      74 
;      75 
;      76 // Declare your global variables here
;      77 /*-----------------------------------------------------------------------------------------
;      78 type 		nom 				       		dsignation       
;      79 ------------------------------------------------------------------------------------------*/
;      80 char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur

	.DSEG
_display_buffer_ligne0:
	.BYTE 0x11
;      81 char display_buffer_ligne1[17]; 	       		// tampon ligne 1 de l'afficheur
_display_buffer_ligne1:
	.BYTE 0x11
;      82 unsigned char heures, minutes, secondes, secondes_1, dizieme; 	//stockage de l'heure
;      83 unsigned char Heure_ou_Date, H_J, mn_mois;
;      84 unsigned int sec_annee;
;      85 
;      86 enum Etat_Test {LedBP,LedTOR,Analog,Temperature,
;      87  	Reglage_HTR,Horloge,Buzzer,EEPROM,RS232Tx,MOT_PWM,REG_PWM} etat=LedBP, etat_1=LedTOR;// Etats du graphe tests	 
_etat:
	.BYTE 0x1
_etat_1:
	.BYTE 0x1
;      88  
;      89 // Constantes en flash
;      90 const char menu[]	= "  [ENTR]=>Oui   ";      

	.CSEG
;      91 const char menuBP[]	= "Test? BP->DEL   "; 
;      92 const char menuTOR[] 	= "Test? TOR->DEL  ";
;      93 const char menuAnalog[] = "Test? E_Analog  "; 
;      94 const char menuBuzzer[] = "Test? Buzzer    "; 
;      95 const char menuEEPROM[] = "Test? EEPROM    ";  
;      96 const char menuRS232[]  = "Test? RS232Tx   "; 
;      97 const char MENU_PWM[]   = "Test? PWMA      ";
;      98 
;      99 // Caractres personnaliss placs dans la mmoire CGRAM du LCD  
;     100 const unsigned char flecheHaut[8] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};    // @1 CGRAM
;     101 const unsigned char flecheBas[8] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};     // @2 CGRAM       
;     102 
;     103 
;     104 // Prototypes des fonctions
;     105 int Led_BP_TOR(char entree);  // test des Leds et des BPs 
;     106 void Affiche_fleches(void);
;     107 
;     108 void main(void)
;     109 { 
_main:
;     110 
;     111 // Declare your local variables here
;     112 // -----------------------------------------------------------------------------------------
;     113 //type 		nom 					dsignation  
;     114 // -------------------------------------------------------------------------------------- --
;     115 
;     116 char display_buffer[32]; 		// Tampon utilis lors de la lecture de la EEPROM
;     117 			 		// en page de 32 octets
;     118 unsigned char i, j, BP;
;     119 unsigned char jour,mois;
;     120 unsigned int  temp_n,annee;  
;     121 unsigned int  mesure,analogU, analogD, analogC; // Calcul de la ddp dlivre par le pot
;     122 unsigned char *Transm; 
;     123 unsigned char rcycl=0, rcycl_1=0;
;     124 unsigned char alpha[11] = {0,25,51,76,102,127,153,178,204,229,255};   // Coefficient pour le rglage du rapport cyclique du 
;     125 									// signal PWM
;     126 // Input/Output Ports initialization
;     127 // Port A
;     128 PORTA=0x3F; // Port A en entre avec rsistance de rappel
	SBIW R28,58
	LDI  R24,12
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x76*2)
	LDI  R31,HIGH(_0x76*2)
	RCALL __INITLOCB
;	display_buffer -> Y+26
;	i -> R16
;	j -> R17
;	BP -> R18
;	jour -> R19
;	mois -> R20
;	temp_n -> Y+24
;	annee -> Y+22
;	mesure -> Y+20
;	analogU -> Y+18
;	analogD -> Y+16
;	analogC -> Y+14
;	*Transm -> Y+12
;	rcycl -> R21
;	rcycl_1 -> Y+11
;	alpha -> Y+0
	LDI  R21,0
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;     129 DDRA=0x00;
	CLR  R30
	OUT  0x1A,R30
;     130 
;     131 // Port B
;     132 PORTB=0x00; // Port B en sortie
	RCALL SUBOPT_0x0
;     133 DDRB=0x1F;
	LDI  R30,LOW(31)
	OUT  0x17,R30
;     134 
;     135 // Port C
;     136 PORTC=0x00; // Port C en sortie
	CLR  R30
	OUT  0x15,R30
;     137 DDRC=0xFF;  // Partag entre le LCD et le Buzzer(PORTC.3)
	LDI  R30,LOW(255)
	OUT  0x14,R30
;     138 
;     139 // Port D initialization
;     140 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=Out Func6=In Func7=In
;     141 // State0=T State1=T State2=T State3=T State4=T State5=0 State6=T State7=T
;     142 PORTD=0x00;
	CLR  R30
	OUT  0x12,R30
;     143 DDRD=0x20;
	LDI  R30,LOW(32)
	OUT  0x11,R30
;     144 
;     145 // Timer/Counter 1 initialization
;     146 // Clock source: System Clock
;     147 // Clock value: 4000,000 kHz
;     148 // Mode: Ph. correct PWM top=00FFh
;     149 // OC1A output: Non-Inv.
;     150 // OC1B output: Discon.
;     151 // Noise Canceler: Off
;     152 // Input Capture on Falling Edge
;     153 TCCR1A=0x81;
	LDI  R30,LOW(129)
	OUT  0x2F,R30
;     154 TCCR1B=0x01;
	LDI  R30,LOW(1)
	OUT  0x2E,R30
;     155 TCNT1H=0x00;
	CLR  R30
	OUT  0x2D,R30
;     156 TCNT1L=0x00;
	OUT  0x2C,R30
;     157 OCR1AH=0x00;
	OUT  0x2B,R30
;     158 OCR1AL=0x00;
	OUT  0x2A,R30
;     159 OCR1BH=0x00;
	OUT  0x29,R30
;     160 OCR1BL=0x00;
	OUT  0x28,R30
;     161 
;     162 // ADC initialization
;     163 // ADC Clock frequency: 31,250 kHz
;     164 ADCSR=0x87;
	LDI  R30,LOW(135)
	OUT  0x6,R30
;     165 
;     166 // UART initialization
;     167 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     168 // UART Receiver: Off
;     169 // UART Transmitter: On
;     170 // UART Baud rate: 19200
;     171 UCR=0x08;
	LDI  R30,LOW(8)
	OUT  0xA,R30
;     172 UBRR=0x0C;
	LDI  R30,LOW(12)
	OUT  0x9,R30
;     173 
;     174 // I2C Bus initialization
;     175 i2c_init();
	RCALL _i2c_init
;     176 
;     177 // DS1621 Thermometer/Thermostat initialization
;     178 // tlow: 24C
;     179 // thigh: 55C
;     180 // Tout polarity: 0
;     181 //ds1621_init(0,24,55,0);
;     182 
;     183 // PCF8583 Real Time Clock initialization
;     184 rtc_init(0,0);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1
	RCALL _rtc_init
;     185 
;     186 // LCD module initialization
;     187 lcd_init(16); 
	RCALL SUBOPT_0x2
	RCALL _lcd_init
;     188 
;     189 // Chargement initial de la mmoire CGRAM de l'afficheur avec les 
;     190 // caractres personaliss
;     191 for (i=0;i<8;i++)
	LDI  R16,LOW(0)
_0x78:
	CPI  R16,8
	BRSH _0x79
;     192 {
;     193 lcd_write_byte(Add_FlecheH_CGRAM + i, flecheHaut[i]); // @1 Caractre flche haut
	MOV  R30,R16
	SUBI R30,-LOW(64)
	ST   -Y,R30
	LDI  R26,LOW(_flecheHaut*2)
	LDI  R27,HIGH(_flecheHaut*2)
	RCALL SUBOPT_0x3
	LPM
	MOV  R30,R0
	RCALL SUBOPT_0x4
;     194 lcd_write_byte(Add_FlecheB_CGRAM + i, flecheBas[i]); // @2 Caractre flche bas
	MOV  R30,R16
	SUBI R30,-LOW(72)
	ST   -Y,R30
	LDI  R26,LOW(_flecheBas*2)
	LDI  R27,HIGH(_flecheBas*2)
	RCALL SUBOPT_0x3
	LPM
	MOV  R30,R0
	RCALL SUBOPT_0x4
;     195 }
	SUBI R16,-1
	RJMP _0x78
_0x79:
;     196 
;     197 sprintf(display_buffer_ligne0,"Test de la carte");
	RCALL SUBOPT_0x5
	__POINTW1FN _117,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     198 sprintf(display_buffer_ligne1,"******S.SI******");
	RCALL SUBOPT_0x7
	__POINTW1FN _117,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     199 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     200 delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RCALL SUBOPT_0x8
;     201 
;     202 while (1)
_0x7A:
;     203       {		   // Dbut While(1)  
;     204        
;     205       BP = Lire_BP();
	RCALL SUBOPT_0x9
;     206       switch (etat)
	LDS  R30,_etat
;     207        {               // Dbut switch (etat)
;     208         case LedBP :   if (etat_1 != etat)
	CPI  R30,0
	BRNE _0x80
	RCALL SUBOPT_0xA
	BREQ _0x81
;     209                         { 
;     210                          sprintf(display_buffer_ligne0,menuBP);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0xB
	LDI  R24,0
	RCALL SUBOPT_0x6
;     211                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xC
	LDI  R24,0
	RCALL SUBOPT_0x6
;     212                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
;     213                          Affiche_fleches();
;     214                         } 
;     215                         switch(BP)
_0x81:
	RCALL SUBOPT_0xE
;     216         		    {
;     217         		     case INC : etat = LedTOR; break;
	BRNE _0x85
	LDI  R30,LOW(1)
	RJMP _0x23E
;     218         		     case DEC : etat = MOT_PWM; break;
_0x85:
	CPI  R30,LOW(0x2F)
	BRNE _0x86
	LDI  R30,LOW(9)
	RJMP _0x23E
;     219         		     case ENTR: Led_BP_TOR(0); //test des BP
_0x86:
	CPI  R30,LOW(0x3E)
	BRNE _0x88
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0xF
;     220        		      			sprintf(display_buffer_ligne0,menuBP);
	RCALL SUBOPT_0xB
	LDI  R24,0
	RCALL SUBOPT_0x6
;     221                   			sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xC
	LDI  R24,0
	RCALL SUBOPT_0x6
;     222                      			Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     223                              break;
	RJMP _0x84
;     224         		     default  : etat = LedBP;
_0x88:
	CLR  R30
_0x23E:
	STS  _etat,R30
;     225         		    }
_0x84:
;     226        			etat_1 = LedBP;
	CLR  R30
	STS  _etat_1,R30
;     227        		        
;     228         break;
	RJMP _0x7F
;     229         
;     230         case LedTOR : if (etat_1 != etat)
_0x80:
	CPI  R30,LOW(0x1)
	BRNE _0x89
	RCALL SUBOPT_0xA
	BREQ _0x8A
;     231                         { 
;     232                          sprintf(display_buffer_ligne0,menuTOR);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x10
	LDI  R24,0
	RCALL SUBOPT_0x6
;     233                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xC
	LDI  R24,0
	RCALL SUBOPT_0x6
;     234                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
;     235                          Affiche_fleches();
;     236                         } 
;     237                         switch(BP)
_0x8A:
	RCALL SUBOPT_0xE
;     238         		    {
;     239         		     case INC : etat = Buzzer; break;
	BRNE _0x8E
	LDI  R30,LOW(6)
	RJMP _0x23F
;     240         		     case DEC : etat = LedBP; break;
_0x8E:
	CPI  R30,LOW(0x2F)
	BRNE _0x8F
	CLR  R30
	RJMP _0x23F
;     241         		     case ENTR: Led_BP_TOR(1); // test des entres TOR
_0x8F:
	CPI  R30,LOW(0x3E)
	BRNE _0x91
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0xF
;     242        		      			sprintf(display_buffer_ligne0,menuTOR);
	RCALL SUBOPT_0x10
	LDI  R24,0
	RCALL SUBOPT_0x6
;     243                   			sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xC
	LDI  R24,0
	RCALL SUBOPT_0x6
;     244                      			Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     245                              break;
	RJMP _0x8D
;     246         		     default  : etat = LedTOR;
_0x91:
	LDI  R30,LOW(1)
_0x23F:
	STS  _etat,R30
;     247         		    }
_0x8D:
;     248        			etat_1 = LedTOR;	
	LDI  R30,LOW(1)
	STS  _etat_1,R30
;     249         break;
	RJMP _0x7F
;     250         
;     251         case Buzzer:	if (etat_1 != etat)
_0x89:
	CPI  R30,LOW(0x6)
	BRNE _0x92
	RCALL SUBOPT_0xA
	BREQ _0x93
;     252                         { 
;     253                          sprintf(display_buffer_ligne0,menuBuzzer);
	RCALL SUBOPT_0x5
	LDI  R30,LOW(_menuBuzzer*2)
	LDI  R31,HIGH(_menuBuzzer*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     254                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xC
	LDI  R24,0
	RCALL SUBOPT_0x6
;     255                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
;     256                          Affiche_fleches();
;     257                         } 
;     258         		switch(BP)
_0x93:
	RCALL SUBOPT_0xE
;     259         		    {
;     260         		     case INC : etat = Analog; break;
	BRNE _0x97
	LDI  R30,LOW(2)
	RJMP _0x240
;     261         		     case DEC : etat = LedTOR; break;
_0x97:
	CPI  R30,LOW(0x2F)
	BRNE _0x99
	LDI  R30,LOW(1)
	RJMP _0x240
;     262         		     default  : etat = Buzzer;
_0x99:
	LDI  R30,LOW(6)
_0x240:
	STS  _etat,R30
;     263         		    }
;     264        			PORTC.3 = !PINA.0;
	CLT
	SBIS 0x19,0
	SET
	IN   R30,0x15
	BLD  R30,3
	OUT  0x15,R30
;     265        			etat_1 = Buzzer;       		
	LDI  R30,LOW(6)
	STS  _etat_1,R30
;     266         break;  
	RJMP _0x7F
;     267         
;     268         case Analog :  	if (etat_1 != etat)
_0x92:
	CPI  R30,LOW(0x2)
	BREQ PC+2
	RJMP _0x9A
	RCALL SUBOPT_0xA
	BREQ _0x9B
;     269                         { 
;     270                          sprintf(display_buffer_ligne0,menuAnalog);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x12
	LDI  R24,0
	RCALL SUBOPT_0x6
;     271                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xC
	LDI  R24,0
	RCALL SUBOPT_0x6
;     272                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
;     273                          Affiche_fleches();
;     274                         } 
;     275                         switch(BP)
_0x9B:
	RCALL SUBOPT_0xE
;     276                          {
;     277         		     case INC : etat = Temperature; break;
	BRNE _0x9F
	LDI  R30,LOW(3)
	RJMP _0x241
;     278         		     case DEC : etat = Buzzer; break;
_0x9F:
	CPI  R30,LOW(0x2F)
	BRNE _0xA0
	LDI  R30,LOW(6)
	RJMP _0x241
;     279         		     case ENTR: sprintf(display_buffer_ligne1,"[ECHP]=>Quit    ");
_0xA0:
	CPI  R30,LOW(0x3E)
	BREQ PC+2
	RJMP _0xA5
	RCALL SUBOPT_0x7
	__POINTW1FN _117,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     280        		       			          
;     281        		      			while (BP != ECHAP) 
_0xA2:
	CPI  R18,59
	BRNE PC+2
	RJMP _0xA4
;     282        		       			{ 
;     283        		       			 BP = Lire_BP();
	RCALL SUBOPT_0x9
;     284        		       			 delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x8
;     285        		       			 mesure = (read_adc(6)/4); // Mesure et calcul de la ddp
	RCALL SUBOPT_0x13
	RCALL _read_adc
	RCALL __LSRW2
	STD  Y+20,R30
	STD  Y+20+1,R31
;     286        		       			 analogU = ((mesure*5)/255);
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
	STD  Y+18,R30
	STD  Y+18+1,R31
;     287        		       			 analogD = ((10*((mesure - (analogU*255)/5))*5)/255);
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x15
	STD  Y+16,R30
	STD  Y+16+1,R31
;     288        		       			 analogC = ((100*(mesure - (analogU*255)/5 -(analogD*255)/50)*5)/255);
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
	PUSH R31
	PUSH R30
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	RCALL SUBOPT_0x14
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL __DIVW21U
	POP  R26
	POP  R27
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x15
	STD  Y+14,R30
	STD  Y+14+1,R31
;     289        		       			 sprintf(display_buffer_ligne0,"  DDP = %-u.%-u%-uV",analogU, analogD, analogC);
	RCALL SUBOPT_0x5
	__POINTW1FN _117,51
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	RCALL SUBOPT_0x19
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RCALL SUBOPT_0x19
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	RCALL SUBOPT_0x19
	LDI  R24,12
	RCALL SUBOPT_0x1A
;     290        		       			 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     291        		       			}
	RJMP _0xA2
_0xA4:
;     292        		       			 sprintf(display_buffer_ligne0,menuAnalog);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x12
	LDI  R24,0
	RCALL SUBOPT_0x6
;     293                     			 sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xC
	LDI  R24,0
	RCALL SUBOPT_0x6
;     294                         		 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);  
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     295        		             break;
	RJMP _0x9E
;     296        			     default  : etat = Analog;
_0xA5:
	LDI  R30,LOW(2)
_0x241:
	STS  _etat,R30
;     297        			   }
_0x9E:
;     298        			etat_1 = Analog;       		
	LDI  R30,LOW(2)
	STS  _etat_1,R30
;     299         break;
	RJMP _0x7F
;     300         
;     301         case Temperature : temp_n = ds1621_temperature_10(0); // Affichage de la temprature toutes les secondes
_0x9A:
	CPI  R30,LOW(0x3)
	BRNE _0xA6
	RCALL SUBOPT_0x1
	RCALL _ds1621_temperature_10
	STD  Y+24,R30
	STD  Y+24+1,R31
;     302         	           rtc_get_time(adresse_HTR,&heures,&minutes,&secondes,&dizieme);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1B
;     303         	       	   if ((etat_1 != etat) || (secondes_1 != secondes))
	BRNE _0xA8
	CP   R7,R8
	BREQ _0xA7
_0xA8:
;     304         		    {  
;     305         		      sprintf(display_buffer_ligne0,"Capteur DS1621  ");
	RCALL SUBOPT_0x5
	__POINTW1FN _117,71
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     306         		      sprintf(display_buffer_ligne1,"Temp. = %-i.%-u%-cC",temp_n/10,abs(temp_n%10),0xdf);
	RCALL SUBOPT_0x7
	__POINTW1FN _117,88
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+28
	LDD  R27,Y+28+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	RCALL SUBOPT_0x19
	LDD  R26,Y+32
	LDD  R27,Y+32+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	ST   -Y,R31
	ST   -Y,R30
	RCALL _abs
	RCALL SUBOPT_0x19
	__GETD1N 0xDF
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL SUBOPT_0x1A
;     307         		      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     308         	              secondes_1 = secondes;   
	MOV  R8,R7
;     309         	              Affiche_fleches();
	RCALL _Affiche_fleches
;     310         	            }
;     311         	           switch(BP)
_0xA7:
	RCALL SUBOPT_0xE
;     312         		    {
;     313         		     case INC : etat = EEPROM; break;
	BRNE _0xAD
	LDI  R30,LOW(7)
	RJMP _0x242
;     314         		     case DEC : etat = Analog; break;
_0xAD:
	CPI  R30,LOW(0x2F)
	BRNE _0xAF
	LDI  R30,LOW(2)
	RJMP _0x242
;     315         		     default  : etat = Temperature;
_0xAF:
	LDI  R30,LOW(3)
_0x242:
	STS  _etat,R30
;     316         		    }
;     317         		   etat_1 = Temperature;
	LDI  R30,LOW(3)
	STS  _etat_1,R30
;     318         break;
	RJMP _0x7F
;     319         
;     320         case EEPROM:	if (etat_1 != etat)
_0xA6:
	CPI  R30,LOW(0x7)
	BRNE _0xB0
	RCALL SUBOPT_0xA
	BREQ _0xB1
;     321                         { 
;     322                          sprintf(display_buffer_ligne0,menuEEPROM);
	RCALL SUBOPT_0x5
	LDI  R30,LOW(_menuEEPROM*2)
	LDI  R31,HIGH(_menuEEPROM*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     323                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xC
	LDI  R24,0
	RCALL SUBOPT_0x6
;     324                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
;     325                          Affiche_fleches(); 
;     326                         }  
;     327                         switch(BP)
_0xB1:
	RCALL SUBOPT_0xE
;     328         		    {
;     329         		     case INC : etat = Horloge; break;
	BRNE _0xB5
	LDI  R30,LOW(5)
	RJMP _0x243
;     330         		     case DEC : etat = Temperature; break;
_0xB5:
	CPI  R30,LOW(0x2F)
	BRNE _0xB6
	LDI  R30,LOW(3)
	RJMP _0x243
;     331         		     case ENTR: j=0;
_0xB6:
	CPI  R30,LOW(0x3E)
	BRNE _0xBB
	LDI  R17,LOW(0)
;     332        		      		        for (i=0;i<8;i++)
	LDI  R16,LOW(0)
_0xB9:
	CPI  R16,8
	BRSH _0xBA
;     333 					 { 
;     334  					   lcd_clear();
	RCALL _lcd_clear
;     335  					   eeprom_page_read(0xae,j,display_buffer); // EEPROM  l'@AE
	LDI  R30,LOW(174)
	ST   -Y,R30
	MOV  R30,R17
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	RCALL _eeprom_page_read
;     336  					   lcd_puts(display_buffer);
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,26
	RCALL SUBOPT_0x1C
;     337  					   delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x8
;     338  					   j=j+32;
	SUBI R17,-LOW(32)
;     339 					 }
	SUBI R16,-1
	RJMP _0xB9
_0xBA:
;     340         		     default  : etat = EEPROM;
_0xBB:
	LDI  R30,LOW(7)
_0x243:
	STS  _etat,R30
;     341         		    }
;     342        			etat_1 = EEPROM;       		
	LDI  R30,LOW(7)
	STS  _etat_1,R30
;     343         break;            
	RJMP _0x7F
;     344         
;     345         case Horloge :  rtc_get_time(adresse_HTR,&heures,&minutes,&secondes,&dizieme);    
_0xB0:
	CPI  R30,LOW(0x5)
	BREQ PC+2
	RJMP _0xBC
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1B
;     346         		if ((etat_1 != etat) || (secondes_1 != secondes))
	BRNE _0xBE
	CP   R7,R8
	BREQ _0xBD
_0xBE:
;     347         		{
;     348         		 rtc_get_date(adresse_HTR,&jour,&mois,&annee);
	RCALL SUBOPT_0x1
	LDI  R30,LOW(19)
	LDI  R31,HIGH(19)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,27
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_get_date
;     349         		 sprintf(display_buffer_ligne0," %-u / %-u / %-i",jour,mois,annee);
	RCALL SUBOPT_0x5
	__POINTW1FN _117,108
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R19
	RCALL SUBOPT_0x1D
	MOV  R30,R20
	RCALL SUBOPT_0x1D
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	RCALL SUBOPT_0x19
	LDI  R24,12
	RCALL SUBOPT_0x1E
;     350         		 sprintf(display_buffer_ligne1,"%-uh / %-umn / %-us ",heures, minutes, secondes);
	RCALL SUBOPT_0x7
	__POINTW1FN _117,125
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x21
	LDI  R24,12
	RCALL SUBOPT_0x1A
;     351         		 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     352         	         secondes_1 = secondes;
	MOV  R8,R7
;     353         	         Affiche_fleches();
	RCALL _Affiche_fleches
;     354         	        }
;     355         		switch(BP)
_0xBD:
	RCALL SUBOPT_0xE
;     356         		{
;     357         		 case INC : etat = RS232Tx; break;
	BRNE _0xC3
	LDI  R30,LOW(8)
	RJMP _0x244
;     358         		 case DEC : etat = EEPROM; break;
_0xC3:
	CPI  R30,LOW(0x2F)
	BRNE _0xC4
	LDI  R30,LOW(7)
	RJMP _0x244
;     359         		 case ENTR : etat = Reglage_HTR; break; 
_0xC4:
	CPI  R30,LOW(0x3E)
	BRNE _0xC6
	LDI  R30,LOW(4)
	RJMP _0x244
;     360         		 default : etat = Horloge;
_0xC6:
	LDI  R30,LOW(5)
_0x244:
	STS  _etat,R30
;     361         		}
;     362         		etat_1 = Horloge;
	LDI  R30,LOW(5)
	STS  _etat_1,R30
;     363         break;     
	RJMP _0x7F
;     364         
;     365         case Reglage_HTR : if (etat_1 != etat)
_0xBC:
	CPI  R30,LOW(0x4)
	BRNE _0xC7
	RCALL SUBOPT_0xA
	BREQ _0xC8
;     366                            {
;     367         	            sprintf(display_buffer_ligne0,"  Reglage HTR");
	RCALL SUBOPT_0x5
	__POINTW1FN _117,146
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     368         	            sprintf(display_buffer_ligne1,"SET>H ETR>Date ");
	RCALL SUBOPT_0x7
	__POINTW1FN _117,160
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     369         	            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     370         		   }   
;     371         		               
;     372         	          switch(BP)
_0xC8:
	MOV  R30,R18
;     373         		   {
;     374         		    case SET   : Heure_ou_Date = 0;
	CPI  R30,LOW(0x3D)
	BRNE _0xCC
	CLR  R10
;     375         		  	        H_J = 12;
	LDI  R30,LOW(12)
	MOV  R11,R30
;     376         		  	        mn_mois = 30;
	LDI  R30,LOW(30)
	MOV  R12,R30
;     377         		  	        sec_annee = 0;
	CLR  R13
	CLR  R14
;     378         		  	        regle_HTR(adresse_HTR,Heure_ou_Date,H_J,mn_mois,sec_annee);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x22
;     379         		  	        etat = Horloge;
	RJMP _0x245
;     380         		    break;
;     381         		 
;     382         		    case ENTR : Heure_ou_Date = 1;
_0xCC:
	CPI  R30,LOW(0x3E)
	BRNE _0xCE
	LDI  R30,LOW(1)
	MOV  R10,R30
;     383         		  	         H_J = 15;
	LDI  R30,LOW(15)
	MOV  R11,R30
;     384         		  	         mn_mois = 6;
	LDI  R30,LOW(6)
	MOV  R12,R30
;     385         		  	         sec_annee = 2008;
	LDI  R30,LOW(2008)
	LDI  R31,HIGH(2008)
	__PUTW1R 13,14
;     386         		  	         regle_HTR(adresse_HTR,Heure_ou_Date,H_J,mn_mois,sec_annee);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x22
;     387         		  	         etat = Horloge;
	RJMP _0x245
;     388         		    break;
;     389         		 
;     390         		    default:     etat = Reglage_HTR;
_0xCE:
	LDI  R30,LOW(4)
_0x245:
	STS  _etat,R30
;     391         		   } 
;     392         	          etat_1 = Reglage_HTR;
	LDI  R30,LOW(4)
	STS  _etat_1,R30
;     393         break; 
	RJMP _0x7F
;     394         
;     395         case RS232Tx:	if (etat_1 != etat)
_0xC7:
	CPI  R30,LOW(0x8)
	BRNE _0xCF
	RCALL SUBOPT_0xA
	BREQ _0xD0
;     396                         { 
;     397                          sprintf(display_buffer_ligne0,menuRS232);
	RCALL SUBOPT_0x5
	LDI  R30,LOW(_menuRS232*2)
	LDI  R31,HIGH(_menuRS232*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     398                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xC
	LDI  R24,0
	RCALL SUBOPT_0x6
;     399                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
;     400                          Affiche_fleches(); 
;     401                         }  
;     402                         switch(BP)
_0xD0:
	RCALL SUBOPT_0xE
;     403         		    {
;     404         		     case INC : etat = MOT_PWM; break;
	BRNE _0xD4
	LDI  R30,LOW(9)
	RJMP _0x246
;     405         		     case DEC : etat = Horloge; break;
_0xD4:
	CPI  R30,LOW(0x2F)
	BRNE _0xD5
	LDI  R30,LOW(5)
	RJMP _0x246
;     406         		     case ENTR: rtc_get_time(adresse_HTR,&heures,&minutes,&secondes,&dizieme);
_0xD5:
	CPI  R30,LOW(0x3E)
	BRNE _0xD7
	RCALL SUBOPT_0x1
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_get_time
;     407         		     sprintf(Transm,"%u/%u/%u",heures, minutes, secondes);
	RCALL SUBOPT_0x23
	__POINTW1FN _117,176
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x21
	LDI  R24,12
	RCALL SUBOPT_0x1E
;     408         		     puts(Transm); 
	RCALL SUBOPT_0x23
	RCALL _puts
;     409         		     break;       
	RJMP _0xD3
;     410         		     default  : etat = RS232Tx;
_0xD7:
	LDI  R30,LOW(8)
_0x246:
	STS  _etat,R30
;     411         		    }
_0xD3:
;     412        			etat_1 = RS232Tx;       		
	LDI  R30,LOW(8)
	STS  _etat_1,R30
;     413         break; 
	RJMP _0x7F
;     414         
;     415         case MOT_PWM :	if (etat_1 != etat)
_0xCF:
	CPI  R30,LOW(0x9)
	BRNE _0xD8
	RCALL SUBOPT_0xA
	BREQ _0xD9
;     416                         { 
;     417                          sprintf(display_buffer_ligne0,MENU_PWM);
	RCALL SUBOPT_0x5
	LDI  R30,LOW(_MENU_PWM*2)
	LDI  R31,HIGH(_MENU_PWM*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     418                          sprintf(display_buffer_ligne1,menu);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xC
	LDI  R24,0
	RCALL SUBOPT_0x6
;     419                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
;     420                          Affiche_fleches(); 
;     421                         }  
;     422                         switch(BP)
_0xD9:
	RCALL SUBOPT_0xE
;     423         		    {
;     424         		     case INC : etat = LedBP; break;
	BRNE _0xDD
	CLR  R30
	RJMP _0x247
;     425         		     case DEC : etat = RS232Tx; break;
_0xDD:
	CPI  R30,LOW(0x2F)
	BRNE _0xDE
	LDI  R30,LOW(8)
	RJMP _0x247
;     426         		     case ENTR: etat = REG_PWM; break; 
_0xDE:
	CPI  R30,LOW(0x3E)
	BRNE _0xE0
	LDI  R30,LOW(10)
	RJMP _0x247
;     427         		     default  : etat = MOT_PWM;
_0xE0:
	LDI  R30,LOW(9)
_0x247:
	STS  _etat,R30
;     428         		    }
;     429        			etat_1 = MOT_PWM;       
	LDI  R30,LOW(9)
	STS  _etat_1,R30
;     430         break;
	RJMP _0x7F
;     431         
;     432         case REG_PWM :  if ((etat_1 != etat)|| (rcycl_1 != rcycl))
_0xD8:
	CPI  R30,LOW(0xA)
	BREQ PC+2
	RJMP _0x7F
	RCALL SUBOPT_0xA
	BRNE _0xE3
	LDD  R26,Y+11
	CP   R21,R26
	BREQ _0xE2
_0xE3:
;     433        			  {
;     434        		   	    sprintf(display_buffer_ligne0,"Rap. cycl = %-u%%",rcycl);
	RCALL SUBOPT_0x5
	__POINTW1FN _117,185
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R21
	RCALL SUBOPT_0x1D
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
;     435        		            sprintf(display_buffer_ligne1,"INC>+ DEC>- ESc>");
	RCALL SUBOPT_0x7
	__POINTW1FN _117,203
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     436        		            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     437        		            rcycl_1 = rcycl; 
	STD  Y+11,R21
;     438 			  }
;     439 		        switch(BP)
_0xE2:
	RCALL SUBOPT_0xE
;     440 			      {
;     441 				case INC: if (rcycl < 90) rcycl = rcycl+10; else rcycl = 100; break;
	BRNE _0xE8
	CPI  R21,90
	BRSH _0xE9
	SUBI R21,-LOW(10)
	RJMP _0xEA
_0xE9:
	LDI  R21,LOW(100)
_0xEA:
	RJMP _0xE7
;     442 				case DEC: if (rcycl > 10) rcycl = rcycl-10; else rcycl = 0; break;
_0xE8:
	CPI  R30,LOW(0x2F)
	BRNE _0xEB
	LDI  R30,LOW(10)
	CP   R30,R21
	BRSH _0xEC
	SUBI R21,LOW(10)
	RJMP _0xED
_0xEC:
	LDI  R21,LOW(0)
_0xED:
	RJMP _0xE7
;     443 				case ECHAP : rcycl = 0; etat = MOT_PWM; break;
_0xEB:
	CPI  R30,LOW(0x3B)
	BRNE _0xEF
	LDI  R21,LOW(0)
	LDI  R30,LOW(9)
	RJMP _0x248
;     444 				default: etat = REG_PWM;
_0xEF:
	LDI  R30,LOW(10)
_0x248:
	STS  _etat,R30
;     445                               }
_0xE7:
;     446 			OCR1A = alpha[rcycl/10];
	MOV  R26,R21
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	CLR  R31
	MOV  R26,R28
	MOV  R27,R29
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	OUT  0x2A+1,R31
	OUT  0x2A,R30
;     447          		etat_1 = REG_PWM ;      		      
	LDI  R30,LOW(10)
	STS  _etat_1,R30
;     448         break;
;     449                    
;     450         
;     451        }; // Fin switch(etat)
_0x7F:
;     452       }  // Fin while(1)    
	RJMP _0x7A
;     453 } // Fin main()
	ADIW R28,58
_0xF0:
	RJMP _0xF0
;     454 
;     455 //===================================================================
;     456 // Sous-programmes
;     457 //-------------------------------------------------------------------
;     458 void Affiche_fleches(void)
;     459 {
_Affiche_fleches:
;     460 lcd_gotoxy(15,0);	// Affichage flecheHaut
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x1
	RCALL _lcd_gotoxy
;     461 		         lcd_putchar(Caractere_FlecheH);	
	RCALL SUBOPT_0x1
	RCALL _lcd_putchar
;     462 			 lcd_gotoxy(15,1);	// Affichage flecheBas
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x11
	RCALL _lcd_gotoxy
;     463 			 lcd_putchar(Caractere_FlecheB);
	RCALL SUBOPT_0x11
	RCALL _lcd_putchar
;     464 }
	RET
;     465 
;     466 // -------------------------------------------------------------------
;     467 
;     468 int Led_BP_TOR(char entree)
;     469 {
_Led_BP_TOR:
;     470   unsigned char BP, Affich=1, sortir=0;
;     471   
;     472   if (entree==0)
	RCALL __SAVELOCR3
;	entree -> Y+3
;	BP -> R16
;	Affich -> R17
;	sortir -> R18
	LDI  R17,1
	LDI  R18,0
	LDD  R30,Y+3
	CPI  R30,0
	BRNE _0xF3
;     473        {
;     474         sprintf(display_buffer_ligne1,"Sortir = 2xECHAP");
	RCALL SUBOPT_0x7
	__POINTW1FN _242,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x249
;     475     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
;     476        }
;     477         else 
_0xF3:
;     478        {
;     479         sprintf(display_buffer_ligne1,"Sortir = 2xPA2");
	RCALL SUBOPT_0x7
	__POINTW1FN _242,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
_0x249:
	RCALL _sprintf
	ADIW R28,4
;     480        	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     481        }
;     482   
;     483   while(sortir<2)
_0xF5:
	CPI  R18,2
	BRLO PC+2
	RJMP _0xF7
;     484   {
;     485    BP=Lire_BP();
	RCALL SUBOPT_0x25
;     486    switch (BP)
	RCALL SUBOPT_0x26
;     487       {
;     488        case INC: PORTB = 0x1F;
	BRNE _0xFB
	LDI  R30,LOW(31)
	OUT  0x18,R30
;     489        		 sprintf(display_buffer_ligne0,"   PA5 -> ALL");
	RCALL SUBOPT_0x5
	__POINTW1FN _242,32
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     490        		 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     491                  Affich = 1;
	LDI  R17,LOW(1)
;     492                  if (sortir=1) sortir=0;
	RCALL SUBOPT_0x27
	BREQ _0xFC
	LDI  R18,LOW(0)
;     493        break; 
_0xFC:
	RJMP _0xFA
;     494        
;     495        case DEC: PORTB.4 = 1;
_0xFB:
	CPI  R30,LOW(0x2F)
	BRNE _0xFD
	SBI  0x18,4
;     496        		 sprintf(display_buffer_ligne0,"   PA4 -> PB4");
	RCALL SUBOPT_0x5
	__POINTW1FN _242,46
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     497        	       	 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     498                  Affich = 1;
	LDI  R17,LOW(1)
;     499                  if (sortir=1) sortir=0;
	RCALL SUBOPT_0x27
	BREQ _0xFE
	LDI  R18,LOW(0)
;     500        	break;
_0xFE:
	RJMP _0xFA
;     501        	 
;     502      	case OK: PORTB.3 = 1;
_0xFD:
	CPI  R30,LOW(0x37)
	BRNE _0xFF
	SBI  0x18,3
;     503      		 sprintf(display_buffer_ligne0,"   PA3 -> PB3");
	RCALL SUBOPT_0x5
	__POINTW1FN _242,60
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     504        	       	 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     505                  Affich = 1; 
	LDI  R17,LOW(1)
;     506                  if (sortir=1) sortir=0;
	RCALL SUBOPT_0x27
	BREQ _0x100
	LDI  R18,LOW(0)
;     507        	break;
_0x100:
	RJMP _0xFA
;     508        	  
;     509       	case SET:PORTB.1 = 1;
_0xFF:
	CPI  R30,LOW(0x3D)
	BRNE _0x101
	SBI  0x18,1
;     510       		 sprintf(display_buffer_ligne0,"   PA1 -> PB1");
	RCALL SUBOPT_0x5
	__POINTW1FN _242,74
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     511         	 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     512                  Affich = 1;
	LDI  R17,LOW(1)
;     513                  if (sortir=1) sortir=0;
	RCALL SUBOPT_0x27
	BREQ _0x102
	LDI  R18,LOW(0)
;     514        	break;
_0x102:
	RJMP _0xFA
;     515        	   
;     516       	case ECHAP: PORTB.2 = 1;
_0x101:
	CPI  R30,LOW(0x3B)
	BRNE _0x103
	SBI  0x18,2
;     517       	            sprintf(display_buffer_ligne0,"   PA2 -> PB2");
	RCALL SUBOPT_0x5
	__POINTW1FN _242,88
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     518        	       	    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     519        		    Affich = 1;
	LDI  R17,LOW(1)
;     520        		    sortir = sortir + 1;
	SUBI R18,-LOW(1)
;     521        	break;
	RJMP _0xFA
;     522        	
;     523        	case ENTR: PORTB.0 = 1;
_0x103:
	CPI  R30,LOW(0x3E)
	BRNE _0x104
	SBI  0x18,0
;     524        		    sprintf(display_buffer_ligne0,"   PA0 -> PB0");
	RCALL SUBOPT_0x5
	__POINTW1FN _242,102
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     525        	       	    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     526                     Affich = 1;
	LDI  R17,LOW(1)
;     527                     if (sortir=1) sortir=0;
	RCALL SUBOPT_0x27
	BREQ _0x105
	LDI  R18,LOW(0)
;     528        	break;
_0x105:
	RJMP _0xFA
;     529        	     
;     530       	case 0xff: PORTB = 0;
_0x104:
	CPI  R30,LOW(0xFF)
	BRNE _0xFA
	RCALL SUBOPT_0x0
;     531       	           if ((Affich == 1)&&(entree==0))
	CPI  R17,1
	BRNE _0x108
	LDD  R26,Y+3
	CPI  R26,LOW(0x0)
	BREQ _0x109
_0x108:
	RJMP _0x107
_0x109:
;     532        	  	    {
;     533        	  	      sprintf(display_buffer_ligne0," Test BPx->DELx");
	RCALL SUBOPT_0x5
	__POINTW1FN _242,116
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     534        	       	      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     535        	       	    }
;     536        	       	    else if  ((Affich == 1)&&(entree==1))
	RJMP _0x10A
_0x107:
	CPI  R17,1
	BRNE _0x10C
	LDD  R26,Y+3
	CPI  R26,LOW(0x1)
	BREQ _0x10D
_0x10C:
	RJMP _0x10B
_0x10D:
;     537        	       	    {
;     538        	  	      sprintf(display_buffer_ligne0,"Test TORx->DELx");
	RCALL SUBOPT_0x5
	__POINTW1FN _242,132
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     539        	       	      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x7
	RCALL _Affiche_LCD
;     540        	       	    }
;     541        	       	    Affich = 0; 
_0x10B:
_0x10A:
	LDI  R17,LOW(0)
;     542        	       	    
;     543        	break;
;     544        }
_0xFA:
;     545   }
	RJMP _0xF5
_0xF7:
;     546 PORTB = 0;   
	RCALL SUBOPT_0x0
;     547 return 0;
	CLR  R30
	CLR  R31
	RCALL __LOADLOCR3
	RJMP _0x23C
;     548 }
;     549 
_Lire_BP:

	.DSEG
_Etat_BP_S4:
	.BYTE 0x1

	.CSEG
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x28
	LDS  R30,_Etat_BP_S4
	CPI  R30,0
	BRNE _0x11C
	CPI  R17,63
	BRNE _0x11D
	MOV  R16,R17
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x28
	CP   R17,R16
	BRNE _0x11E
	LDI  R30,LOW(1)
	STS  _Etat_BP_S4,R30
	LDI  R30,LOW(255)
	RJMP _0x23D
_0x11E:
	CLR  R30
	RJMP _0x23D
	RJMP _0x120
_0x11D:
	CLR  R30
	RJMP _0x23D
_0x120:
	RJMP _0x11B
_0x11C:
	CPI  R30,LOW(0x1)
	BRNE _0x11B
	CPI  R17,63
	BREQ _0x122
	MOV  R16,R17
	RCALL SUBOPT_0x29
	ANDI R17,LOW(63)
	CP   R17,R16
	BRNE _0x123
	CLR  R30
	STS  _Etat_BP_S4,R30
	MOV  R30,R17
	RJMP _0x23D
_0x123:
	LDI  R30,LOW(255)
	RJMP _0x23D
	RJMP _0x125
_0x122:
	LDI  R30,LOW(255)
_0x125:
_0x11B:
_0x23D:
	RCALL __LOADLOCR2P
	RET
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x11
	RCALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1C
_0x23C:
	ADIW R28,4
	RET
_eeprom_page_read:
	SBIW R28,3
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   Y,R30
	LDD  R30,Y+6
	ANDI R31,HIGH(0x0)
	STD  Y+1,R30
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x2E
	CLR  R30
	STD  Y+2,R30
_0x129:
	LDD  R26,Y+2
	CPI  R26,LOW(0x1F)
	BRSH _0x12A
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x2F
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	LD   R30,X+
	STD  Y+3,R26
	STD  Y+3+1,R27
	LDD  R30,Y+2
	SUBI R30,-LOW(1)
	STD  Y+2,R30
	RJMP _0x129
_0x12A:
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2F
	RCALL _i2c_stop
	ADIW R28,8
	RET
_regle_HTR:
	SBIW R28,35
	RCALL __SAVELOCR6
	LDI  R21,LOW(0)
_0x12C:
	RCALL SUBOPT_0x25
	MOV  R30,R21
	CPI  R30,0
	BREQ PC+2
	RJMP _0x132
	RCALL SUBOPT_0x30
	BRNE _0x133
	LDD  R26,Y+44
	CPI  R26,LOW(0x18)
	BRNE _0x134
	RCALL SUBOPT_0x31
_0x134:
	LDD  R26,Y+44
	CPI  R26,LOW(0xFF)
	BRNE _0x135
	LDI  R30,LOW(23)
	STD  Y+44,R30
_0x135:
	RCALL SUBOPT_0x32
	BRNE _0x137
	RCALL SUBOPT_0x33
	BREQ _0x136
_0x137:
	RCALL SUBOPT_0x34
	__POINTW1FN _299,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x35
	__POINTW1FN _299,17
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
	LDI  R24,12
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x39
	LDD  R17,Y+44
_0x136:
	RJMP _0x139
_0x133:
	LDD  R26,Y+44
	CPI  R26,LOW(0x20)
	BRNE _0x13A
	RCALL SUBOPT_0x31
_0x13A:
	LDD  R30,Y+44
	CPI  R30,0
	BRNE _0x13B
	LDI  R30,LOW(31)
	STD  Y+44,R30
_0x13B:
	RCALL SUBOPT_0x32
	BRNE _0x13D
	RCALL SUBOPT_0x33
	BREQ _0x13C
_0x13D:
	RCALL SUBOPT_0x34
	__POINTW1FN _299,37
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x35
	__POINTW1FN _299,53
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
	LDI  R24,12
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x39
	LDD  R17,Y+44
_0x13C:
_0x139:
	RCALL SUBOPT_0x26
	BRNE _0x142
	LDD  R30,Y+44
	SUBI R30,-LOW(1)
	STD  Y+44,R30
	RJMP _0x141
_0x142:
	CPI  R30,LOW(0x2F)
	BRNE _0x143
	LDD  R30,Y+44
	SUBI R30,LOW(1)
	STD  Y+44,R30
	RJMP _0x141
_0x143:
	CPI  R30,LOW(0x37)
	BRNE _0x144
	LDI  R21,LOW(1)
	RJMP _0x141
_0x144:
	CPI  R30,LOW(0x3B)
	BRNE _0x146
	LDI  R21,LOW(3)
	RJMP _0x141
_0x146:
	LDI  R21,LOW(0)
_0x141:
	CLR  R30
	STD  Y+40,R30
	RJMP _0x131
_0x132:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x147
	RCALL SUBOPT_0x30
	BRNE _0x148
	LDD  R26,Y+43
	CPI  R26,LOW(0x3C)
	BRNE _0x149
	CLR  R30
	STD  Y+43,R30
_0x149:
	LDD  R26,Y+43
	CPI  R26,LOW(0xFF)
	BRNE _0x14A
	LDI  R30,LOW(59)
	STD  Y+43,R30
_0x14A:
	RCALL SUBOPT_0x3A
	BRNE _0x14C
	RCALL SUBOPT_0x33
	BREQ _0x14B
_0x14C:
	RCALL SUBOPT_0x34
	__POINTW1FN _299,68
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x35
	__POINTW1FN _299,84
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
	LDI  R24,12
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x39
	LDD  R18,Y+43
_0x14B:
	RJMP _0x14E
_0x148:
	LDD  R26,Y+43
	CPI  R26,LOW(0xD)
	BRNE _0x14F
	LDI  R30,LOW(1)
	STD  Y+43,R30
_0x14F:
	LDD  R30,Y+43
	CPI  R30,0
	BRNE _0x150
	LDI  R30,LOW(12)
	STD  Y+43,R30
_0x150:
	RCALL SUBOPT_0x3A
	BRNE _0x152
	RCALL SUBOPT_0x33
	BREQ _0x151
_0x152:
	RCALL SUBOPT_0x34
	__POINTW1FN _299,105
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x35
	__POINTW1FN _299,121
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
	LDI  R24,12
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x39
	LDD  R18,Y+43
_0x151:
_0x14E:
	RCALL SUBOPT_0x26
	BRNE _0x157
	LDD  R30,Y+43
	SUBI R30,-LOW(1)
	STD  Y+43,R30
	RJMP _0x156
_0x157:
	CPI  R30,LOW(0x2F)
	BRNE _0x158
	LDD  R30,Y+43
	SUBI R30,LOW(1)
	STD  Y+43,R30
	RJMP _0x156
_0x158:
	CPI  R30,LOW(0x37)
	BRNE _0x159
	LDI  R21,LOW(2)
	RJMP _0x156
_0x159:
	CPI  R30,LOW(0x3B)
	BRNE _0x15B
	LDI  R21,LOW(3)
	RJMP _0x156
_0x15B:
	LDI  R21,LOW(1)
_0x156:
	LDI  R30,LOW(1)
	STD  Y+40,R30
	RJMP _0x131
_0x147:
	CPI  R30,LOW(0x2)
	BREQ PC+2
	RJMP _0x15C
	RCALL SUBOPT_0x30
	BRNE _0x15D
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CPI  R26,LOW(0x3C)
	LDI  R30,HIGH(0x3C)
	CPC  R27,R30
	BRNE _0x15E
	CLR  R30
	STD  Y+41,R30
	STD  Y+41+1,R30
_0x15E:
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CPI  R26,LOW(0xFFFF)
	LDI  R30,HIGH(0xFFFF)
	CPC  R27,R30
	BRNE _0x15F
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	STD  Y+41,R30
	STD  Y+41+1,R31
_0x15F:
	RCALL SUBOPT_0x3B
	BRNE _0x161
	RCALL SUBOPT_0x33
	BREQ _0x160
_0x161:
	RCALL SUBOPT_0x34
	__POINTW1FN _299,136
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x35
	__POINTW1FN _299,152
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
	LDI  R24,12
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x39
	__GETWRS 19,20,41
_0x160:
	RJMP _0x163
_0x15D:
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CPI  R26,LOW(0x834)
	LDI  R30,HIGH(0x834)
	CPC  R27,R30
	BRNE _0x164
	RCALL SUBOPT_0x3C
_0x164:
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CPI  R26,LOW(0x7CF)
	LDI  R30,HIGH(0x7CF)
	CPC  R27,R30
	BRNE _0x165
	RCALL SUBOPT_0x3C
_0x165:
	RCALL SUBOPT_0x3B
	BRNE _0x167
	RCALL SUBOPT_0x33
	BREQ _0x166
_0x167:
	RCALL SUBOPT_0x34
	__POINTW1FN _299,172
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x35
	__POINTW1FN _299,188
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
	LDI  R24,12
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x39
	__GETWRS 19,20,41
_0x166:
_0x163:
	RCALL SUBOPT_0x26
	BRNE _0x16C
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	ADIW R30,1
	STD  Y+41,R30
	STD  Y+41+1,R31
	RJMP _0x16B
_0x16C:
	CPI  R30,LOW(0x2F)
	BRNE _0x16D
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	SBIW R30,1
	STD  Y+41,R30
	STD  Y+41+1,R31
	RJMP _0x16B
_0x16D:
	CPI  R30,LOW(0x37)
	BRNE _0x16E
	LDI  R21,LOW(0)
	RJMP _0x16B
_0x16E:
	CPI  R30,LOW(0x3B)
	BRNE _0x170
	LDI  R21,LOW(3)
	RJMP _0x16B
_0x170:
	LDI  R21,LOW(2)
_0x16B:
	LDI  R30,LOW(2)
	STD  Y+40,R30
	RJMP _0x131
_0x15C:
	CPI  R30,LOW(0x3)
	BRNE _0x131
	LDD  R26,Y+45
	CPI  R26,LOW(0x1)
	BRNE _0x172
	RCALL SUBOPT_0x3D
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_set_date
	RJMP _0x173
_0x172:
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x3E
	RCALL _rtc_set_time
_0x173:
	CLR  R30
	CLR  R31
	RJMP _0x23B
_0x131:
	RJMP _0x12C
_0x23B:
	RCALL __LOADLOCR6
	ADIW R28,47
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	RCALL SUBOPT_0x3F
	SBIW R30,0
	BREQ _0x1AA
	RCALL SUBOPT_0x3F
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOV  R26,R30
	MOV  R27,R31
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x1AB
_0x1AA:
	RCALL SUBOPT_0x40
	RCALL _putchar
_0x1AB:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x1AD:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM
	MOV  R30,R0
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x1AF
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x1B3
	CPI  R19,37
	BRNE _0x1B4
	LDI  R16,LOW(1)
	RJMP _0x1B5
_0x1B4:
	RCALL SUBOPT_0x41
_0x1B5:
	RJMP _0x1B2
_0x1B3:
	CPI  R30,LOW(0x1)
	BRNE _0x1B6
	CPI  R19,37
	BRNE _0x1B7
	RCALL SUBOPT_0x41
	LDI  R16,LOW(0)
	RJMP _0x1B2
_0x1B7:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x1B8
	LDI  R17,LOW(1)
	RJMP _0x1B2
_0x1B8:
	CPI  R19,43
	BRNE _0x1B9
	LDI  R21,LOW(43)
	RJMP _0x1B2
_0x1B9:
	CPI  R19,32
	BRNE _0x1BA
	LDI  R21,LOW(32)
	RJMP _0x1B2
_0x1BA:
	RJMP _0x1BB
_0x1B6:
	CPI  R30,LOW(0x2)
	BRNE _0x1BC
_0x1BB:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x1BD
	ORI  R17,LOW(128)
	RJMP _0x1B2
_0x1BD:
	RJMP _0x1BE
_0x1BC:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x1B2
_0x1BE:
	CPI  R19,48
	BRLO _0x1C1
	CPI  R19,58
	BRLO _0x1C2
_0x1C1:
	RJMP _0x1C0
_0x1C2:
	MOV  R18,R20
	LSL  R20
	LSL  R20
	ADD  R20,R18
	LSL  R20
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x1B2
_0x1C0:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x1C6
	RCALL SUBOPT_0x42
	LD   R30,X
	RCALL SUBOPT_0x43
	RJMP _0x1C7
_0x1C6:
	CPI  R30,LOW(0x73)
	BRNE _0x1C9
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x44
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x1CA
_0x1C9:
	CPI  R30,LOW(0x70)
	BRNE _0x1CC
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x44
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x1CA:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x1CD
_0x1CC:
	CPI  R30,LOW(0x64)
	BREQ _0x1D0
	CPI  R30,LOW(0x69)
	BRNE _0x1D1
_0x1D0:
	ORI  R17,LOW(4)
	RJMP _0x1D2
_0x1D1:
	CPI  R30,LOW(0x75)
	BRNE _0x1D3
_0x1D2:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x1D4
_0x1D3:
	CPI  R30,LOW(0x58)
	BRNE _0x1D6
	ORI  R17,LOW(8)
	RJMP _0x1D7
_0x1D6:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x205
_0x1D7:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x1D4:
	SBRS R17,2
	RJMP _0x1D9
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x45
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x1DA
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x1DA:
	CPI  R21,0
	BREQ _0x1DB
	SUBI R16,-LOW(1)
	RJMP _0x1DC
_0x1DB:
	ANDI R17,LOW(251)
_0x1DC:
	RJMP _0x1DD
_0x1D9:
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x45
_0x1DD:
_0x1CD:
	SBRC R17,0
	RJMP _0x1DE
_0x1DF:
	CP   R16,R20
	BRSH _0x1E1
	SBRS R17,7
	RJMP _0x1E2
	SBRS R17,2
	RJMP _0x1E3
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x1E4
_0x1E3:
	LDI  R19,LOW(48)
_0x1E4:
	RJMP _0x1E5
_0x1E2:
	LDI  R19,LOW(32)
_0x1E5:
	RCALL SUBOPT_0x41
	SUBI R20,LOW(1)
	RJMP _0x1DF
_0x1E1:
_0x1DE:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x1E6
_0x1E7:
	CPI  R18,0
	BREQ _0x1E9
	SBRS R17,3
	RJMP _0x1EA
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM
	MOV  R30,R0
	RJMP _0x24A
_0x1EA:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x24A:
	ST   -Y,R30
	RCALL SUBOPT_0x46
	CPI  R20,0
	BREQ _0x1EC
	SUBI R20,LOW(1)
_0x1EC:
	SUBI R18,LOW(1)
	RJMP _0x1E7
_0x1E9:
	RJMP _0x1ED
_0x1E6:
_0x1EF:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x1F1
	SBRS R17,3
	RJMP _0x1F2
	SUBI R19,-LOW(7)
	RJMP _0x1F3
_0x1F2:
	SUBI R19,-LOW(39)
_0x1F3:
_0x1F1:
	SBRC R17,4
	RJMP _0x1F5
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x1F7
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x1F6
_0x1F7:
	ORI  R17,LOW(16)
	RJMP _0x1F9
_0x1F6:
	CP   R20,R18
	BRLO _0x1FB
	SBRS R17,0
	RJMP _0x1FC
_0x1FB:
	RJMP _0x1FA
_0x1FC:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x1FD
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x1F9:
	SBRS R17,2
	RJMP _0x1FE
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x46
	CPI  R20,0
	BREQ _0x1FF
	SUBI R20,LOW(1)
_0x1FF:
_0x1FE:
_0x1FD:
_0x1F5:
	RCALL SUBOPT_0x41
	CPI  R20,0
	BREQ _0x200
	SUBI R20,LOW(1)
_0x200:
_0x1FA:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x1F0
	RJMP _0x1EF
_0x1F0:
_0x1ED:
	SBRS R17,0
	RJMP _0x201
_0x202:
	CPI  R20,0
	BREQ _0x204
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x43
	RJMP _0x202
_0x204:
_0x201:
_0x205:
_0x1C7:
	LDI  R16,LOW(0)
_0x1B2:
	RJMP _0x1AD
_0x1AF:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOV  R26,R28
	MOV  R27,R29
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,6
	RCALL SUBOPT_0x47
	ST   Y,R30
	STD  Y+1,R31
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,4
	RCALL SUBOPT_0x47
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	RJMP _0x238
_ds1621_temperature_10:
	SBIW R28,2
	ST   -Y,R16
	LDD  R30,Y+3
	LSL  R30
	ORI  R30,LOW(0x90)
	RCALL SUBOPT_0x48
	LDI  R30,LOW(170)
	RCALL SUBOPT_0x2B
	RCALL _i2c_start
	SUBI R16,-LOW(1)
	ST   -Y,R16
	RCALL _i2c_write
	RCALL SUBOPT_0x11
	RCALL _i2c_read
	STD  Y+2,R30
	RCALL SUBOPT_0x1
	RCALL _i2c_read
	STD  Y+1,R30
	RCALL _i2c_stop
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R30,LOW(7)
	RCALL __ASRW12
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RCALL __MULW12
	LDD  R16,Y+0
	RJMP _0x238
_rtc_read:
	ST   -Y,R16
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x2C
	RCALL _i2c_start
	MOV  R30,R16
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x1
	RCALL _i2c_read
	MOV  R16,R30
	RCALL _i2c_stop
	MOV  R30,R16
	LDD  R16,Y+0
	RJMP _0x239
_rtc_write:
	RCALL _i2c_start
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2D
	RCALL _i2c_stop
	RJMP _0x239
_rtc_get_status:
	RCALL SUBOPT_0x4A
	RCALL _rtc_read
	MOV  R4,R30
	BST  R4,1
	BLD  R2,0
	MOV  R30,R4
	RJMP _0x23A
_rtc_init:
	ST   -Y,R16
	LDI  R16,LOW(144)
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x21B
	LDI  R16,LOW(176)
_0x21B:
	CLR  R4
	CLT
	BLD  R2,0
	LDD  R30,Y+2
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x4B
	RCALL SUBOPT_0x4C
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x4C
	RCALL _rtc_read
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x4B
	LDI  R30,LOW(8)
	ST   -Y,R30
	ST   -Y,R16
	RCALL _rtc_write
	LDD  R16,Y+0
	RJMP _0x239
_rtc_stop:
	RCALL SUBOPT_0x4F
	ORI  R30,0x80
	RCALL SUBOPT_0x50
	RCALL SUBOPT_0x51
	RJMP _0x23A
_rtc_start:
	RCALL SUBOPT_0x4F
	ANDI R30,0x7F
	RCALL SUBOPT_0x50
	RCALL SUBOPT_0x51
	RJMP _0x23A
_rtc_hold_off:
	RCALL SUBOPT_0x4F
	ANDI R30,0xBF
	RCALL SUBOPT_0x50
	RCALL SUBOPT_0x51
	RJMP _0x23A
_rtc_hold_on:
	RCALL SUBOPT_0x4F
	ORI  R30,0x40
	RCALL SUBOPT_0x50
	RCALL SUBOPT_0x51
_0x23A:
	ADIW R28,1
	RET
_rtc_read_bcd:
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x52
	RCALL _rtc_read
	RCALL SUBOPT_0x53
	ADIW R28,2
	RET
_rtc_write_bcd:
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x40
	RCALL _bin2bcd
	RCALL SUBOPT_0x54
_0x239:
	ADIW R28,3
	RET
_rtc_write_word:
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x40
	RCALL _rtc_write
	RCALL SUBOPT_0x55
	LDD  R30,Y+3
	SUBI R30,-LOW(1)
	STD  Y+3,R30
	ST   -Y,R30
	LDD  R30,Y+3
	ANDI R31,HIGH(0x0)
	RCALL SUBOPT_0x54
_0x238:
	ADIW R28,4
	RET
_rtc_write_date:
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x4D
	RCALL _bin2bcd
	PUSH R30
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	LSL  R30
	POP  R26
	OR   R30,R26
	RCALL SUBOPT_0x54
	RJMP _0x237
_rtc_get_time:
	RCALL SUBOPT_0x56
	RCALL _rtc_hold_on
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x11
	RCALL _rtc_read_bcd
	LD   R26,Y
	LDD  R27,Y+1
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x58
	RCALL _rtc_read_bcd
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x59
	RCALL _rtc_read_bcd
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x4C
	RCALL _rtc_read_bcd
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL SUBOPT_0x57
	RCALL _rtc_hold_off
	ADIW R28,9
	RET
_rtc_set_time:
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x5A
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x58
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x59
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x4C
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5B
	RCALL _rtc_start
	RJMP _0x237
_rtc_get_date:
	SBIW R28,3
	RCALL SUBOPT_0x5D
	RCALL _rtc_hold_on
	RCALL SUBOPT_0x5D
	RCALL SUBOPT_0x5E
	RCALL _rtc_read
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x13
	RCALL _rtc_read
	ANDI R30,LOW(0x1F)
	RCALL SUBOPT_0x53
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ST   X,R30
	RCALL SUBOPT_0x5D
	RCALL _rtc_hold_off
	LDD  R30,Y+2
	RCALL SUBOPT_0x4E
	RCALL _bcd2bin
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	ST   X,R30
	LDD  R30,Y+2
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	LSR  R30
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x2
	RCALL _rtc_read
	PUSH R30
	RCALL SUBOPT_0x5D
	LDI  R30,LOW(17)
	ST   -Y,R30
	RCALL _rtc_read
	MOV  R31,R30
	CLR  R30
	POP  R26
	CLR  R27
	OR   R30,R26
	OR   R31,R27
	ST   Y,R30
	STD  Y+1,R31
	LD   R30,Y
	ANDI R30,LOW(0x3)
	MOV  R26,R30
	LDD  R30,Y+2
	CP   R30,R26
	BREQ _0x227
	RCALL SUBOPT_0x5D
	RCALL SUBOPT_0x2
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RCALL SUBOPT_0x60
_0x227:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL __PUTWP1
	ADIW R28,10
	RET
_rtc_set_date:
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x2
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x60
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x5A
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x5C
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_write_date
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x5B
	RCALL _rtc_start
_0x237:
	ADIW R28,5
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G8:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_write_byte:
	RCALL __lcd_ready
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x61
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	RCALL SUBOPT_0x62
	ADIW R28,2
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G8:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G8)
	SBCI R31,HIGH(-__base_y_G8)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x62
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	RCALL SUBOPT_0x58
	RCALL SUBOPT_0x61
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x11
	RCALL __lcd_write_data
	CLR  R30
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R30,R26
	BRSH _0x230
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	RCALL SUBOPT_0x1
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x230:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G8:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G8:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G8,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G8,3
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x63
	RCALL __long_delay_G8
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G8
	RCALL __long_delay_G8
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x62
	RCALL __long_delay_G8
	RCALL SUBOPT_0x4C
	RCALL __lcd_write_data
	RCALL __long_delay_G8
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x62
	RCALL __long_delay_G8
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G8
	CPI  R30,LOW(0x5)
	BREQ _0x235
	CLR  R30
	RJMP _0x236
_0x235:
	RCALL __lcd_ready
	RCALL SUBOPT_0x13
	RCALL __lcd_write_data
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x236:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x0:
	CLR  R30
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES
SUBOPT_0x1:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(16)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	MOV  R30,R16
	CLR  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	ST   -Y,R30
	RJMP _lcd_write_byte

;OPTIMIZER ADDED SUBROUTINE, CALLED 49 TIMES
SUBOPT_0x5:
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 41 TIMES
SUBOPT_0x6:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 43 TIMES
SUBOPT_0x7:
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	RCALL _Lire_BP
	MOV  R18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0xA:
	LDS  R30,_etat
	LDS  R26,_etat_1
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	LDI  R30,LOW(_menuBP*2)
	LDI  R31,HIGH(_menuBP*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0xC:
	LDI  R30,LOW(_menu*2)
	LDI  R31,HIGH(_menu*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0xD:
	RCALL _Affiche_LCD
	RJMP _Affiche_fleches

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0xE:
	MOV  R30,R18
	CPI  R30,LOW(0x1F)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	RCALL _Led_BP_TOR
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	LDI  R30,LOW(_menuTOR*2)
	LDI  R31,HIGH(_menuTOR*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x11:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	LDI  R30,LOW(_menuAnalog*2)
	LDI  R31,HIGH(_menuAnalog*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x13:
	LDI  R30,LOW(6)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x14:
	RCALL __MULW12U
	MOV  R26,R30
	MOV  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x15:
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	RCALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL __DIVW21U
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	RCALL __MULW12U
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x19:
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1A:
	RCALL _sprintf
	ADIW R28,16
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_get_time
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1C:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES
SUBOPT_0x1D:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x1E:
	RCALL _sprintf
	ADIW R28,16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1F:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R5
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	MOV  R30,R6
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x21:
	MOV  R30,R7
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x22:
	ST   -Y,R10
	ST   -Y,R11
	ST   -Y,R12
	ST   -Y,R14
	ST   -Y,R13
	RCALL _regle_HTR
	LDI  R30,LOW(5)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x23:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x24:
	LDI  R30,LOW(15)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	RCALL _Lire_BP
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x26:
	MOV  R30,R16
	CPI  R30,LOW(0x1F)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x27:
	LDI  R30,LOW(1)
	MOV  R18,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x28:
	IN   R30,0x19
	ANDI R30,LOW(0x3F)
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x29:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
	RCALL _i2c_start
	LDD  R30,Y+7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x2B:
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x2C:
	LDD  R30,Y+1
	RJMP SUBOPT_0x2B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2D:
	LD   R30,Y
	RJMP SUBOPT_0x2B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2E:
	ORI  R30,1
	RJMP SUBOPT_0x2B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2F:
	RCALL _i2c_read
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x30:
	LDD  R30,Y+45
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x31:
	CLR  R30
	STD  Y+44,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x32:
	LDD  R30,Y+44
	CP   R30,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x33:
	LDD  R26,Y+40
	CP   R21,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x34:
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x35:
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x36:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+48
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x37:
	LDD  R30,Y+51
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x38:
	LDD  R30,Y+53
	LDD  R31,Y+53+1
	RCALL __CWD1
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x39:
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Affiche_LCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3A:
	LDD  R30,Y+43
	CP   R30,R18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3B:
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	CP   R30,R19
	CPC  R31,R20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3C:
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,43
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3D:
	LDD  R30,Y+46
	ST   -Y,R30
	LDD  R30,Y+45
	ST   -Y,R30
	LDD  R30,Y+45
	ST   -Y,R30
	LDD  R30,Y+44
	LDD  R31,Y+44+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x3E:
	ST   -Y,R30
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3F:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x40:
	LDD  R30,Y+2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x41:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x42:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x43:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x44:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x45:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x46:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x47:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x48:
	MOV  R16,R30
	RCALL _i2c_start
	ST   -Y,R16
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x49:
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0xA0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x4A:
	LD   R30,Y
	RJMP SUBOPT_0x3E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4B:
	RCALL _rtc_write
	RJMP SUBOPT_0x40

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x4C:
	LDI  R30,LOW(4)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES
SUBOPT_0x4D:
	LDD  R30,Y+4
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4E:
	ANDI R30,LOW(0x3F)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4F:
	LD   R30,Y
	ST   -Y,R30
	RCALL _rtc_get_status
	MOV  R30,R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x50:
	MOV  R4,R30
	RJMP SUBOPT_0x4A

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x51:
	ST   -Y,R4
	RJMP _rtc_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x52:
	LDD  R30,Y+1
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x53:
	ST   -Y,R30
	RJMP _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x54:
	ST   -Y,R30
	RJMP _rtc_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x55:
	LDD  R30,Y+3
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x56:
	LDD  R30,Y+8
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x57:
	ST   X,R30
	RJMP SUBOPT_0x56

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x58:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x59:
	LDI  R30,LOW(3)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5A:
	RCALL _rtc_stop
	RJMP SUBOPT_0x4D

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x5B:
	RCALL _rtc_write_bcd
	RJMP SUBOPT_0x4D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5C:
	LDD  R30,Y+5
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x5D:
	LDD  R30,Y+9
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5E:
	LDI  R30,LOW(5)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5F:
	STD  Y+2,R30
	RJMP SUBOPT_0x5D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x60:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _rtc_write_word

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x61:
	RCALL __lcd_write_data
	RJMP __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x62:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x63:
	RCALL __long_delay_G8
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G8

_abs:
	ld   r30,y+
	ld   r31,y+
	sbiw r30,0
	brpl __abs0
	com  r30
	com  r31
	adiw r30,1
__abs0:
	ret

	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,7
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,13
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_puts:
	ld   r30,y+
	ld   r31,y+
__puts0:
	ld   r22,z+
	tst  r22
	breq __puts1
	push r30
	push r31
	rcall __puts2
	pop  r31
	pop  r30
	rjmp __puts0
__puts1:
	ldi  r22,10
__puts2:
	st   -y,r22
	rjmp _putchar

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm 
	tst  r0
	breq __strlenf1
	adiw r26,1
	adiw r30,1
	rjmp __strlenf0
__strlenf1:
	mov  r30,r26
	mov  r31,r27
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_bcd2bin:
	ld   r30,y
	swap r30
	andi r30,0xf
	mov  r26,r30
	lsl  r26
	lsl  r26
	add  r30,r26
	lsl  r30
	ld   r26,y+
	andi r26,0xf
	add  r30,r26
	ret

_bin2bcd:
	ld   r26,y+
	clr  r30
__bin2bcd0:
	subi r26,10
	brmi __bin2bcd1
	subi r30,-16
	rjmp __bin2bcd0
__bin2bcd1:
	subi r26,-10
	add  r30,r26
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	MOV  R31,R27
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__MULW12U:
	MOV  R0,R26
	MOV  R1,R27
	LDI  R24,17
	CLR  R26
	SUB  R27,R27
	RJMP __MULW12U1
__MULW12U3:
	BRCC __MULW12U2
	ADD  R26,R0
	ADC  R27,R1
__MULW12U2:
	LSR  R27
	ROR  R26
__MULW12U1:
	ROR  R31
	ROR  R30
	DEC  R24
	BRNE __MULW12U3
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOV  R30,R26
	MOV  R31,R27
	MOV  R26,R0
	MOV  R27,R1
	RET

__MODW21U:
	RCALL __DIVW21U
	MOV  R30,R26
	MOV  R31,R27
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM 
	MOV  R31,R0
	MOV  R30,R1
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM
	ADIW R30,1
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

